TheTwelveYearOld

joined 2 years ago
 

I looked at KWin::Window on the Kwin scripting API page but didn’t find any ways to make a given window become maximized.

 

It says on https://support.mozilla.org/en-US/kb/about-picture-picture-firefox#w_keyboard-shortcuts that the hotkey to toggle PiP is CTRL Shift ]. When I play a video it shows the PiP button, but the hotkey doesn't work. The other PiP keys like seeking and volume work. I'm on Fedora 41 with KDE 6.3.3 & Wayland.

 

I did some looking and there doesn't seem to be one, unless you know of any. Ideally I want a modal file manager like Yazi: it's keys are highly inspired by vim with H J K L navigation (H & L for traversing directories), a visual mode for selecting files, and lots of commands and customization. The one thing its missing is a grid view to preview image files. None of the orthodox file manager seem to have one, including Krusader which I just looked at. I'd love to finally stop using the mouse for file management and could go with either a TUI or GUI manager.

 

Right now when you go to settings and click on the cell for a search engine under the keyword column, it shows a text box for me to add keywords to use in the URL bar. You can't do so for bookmarks, tabs, or history which are locked to * % and ^ respectively.

 

Edit: I edited the script to take a screenshot asynchronously, get the region with slurp, and use magickto crop it. I also multiply the values from slurp 2x to account for the 200% display scaling I have.

  #!/bin/bash 

	die(){
    notify-send "$1"
    exit 1
  }
  cleanup(){
    [[ -n $1 ]] && rm -r "$1"
  }
  SCR_IMG=$(mktemp -d) || die "failed to take screenshot"
  trap "cleanup '$SCR_IMG'" EXIT

	spectacle -nbo "$SCR_IMG/scr.tiff" &
	region=($(slurp -b "#00000000" -c "#80808080" -w 2 -f "%w %h %x %y"))
	for i in "${!region[@]}" 
	do
		region[i]=$(expr ${region[i]} "*" "2")
	done
	magick "$SCR_IMG/scr.tiff" -crop "${region[0]}x${region[1]}+${region[2]}+${region[3]}" "$SCR_IMG/scr.tiff" 

	tesseract "$SCR_IMG/scr.tiff" "$SCR_IMG/scr" &> /dev/null || die "failed to extract text"
  wl-copy < "$SCR_IMG/scr.txt" || die "failed to copy text to clipboard"
  notify-send "Text extracted from image" "$(head -c 100 "$SCR_IMG/scr.txt")" || die "failed to send notification"
  exit

I'm using this script from HN* to select regions on the screen and copy their text, I took out the line with mogrify. It uses spectacle but it takes a moment before opening the UI, is it possible and would it be faster if Spectacle stayed open in the background? The slurp CLI starts instantly for me for selecting regions, I looked for command line screenshot tools to maybe use with it or has its own region support but didn't find any. Neither maim scrot and grim don't work on Plasma Wayland. I installed the ksnip flatpak but the option for rectangular regions doesn't show for me.

* The script:

  #!/bin/bash 
  # Dependencies: tesseract-ocr imagemagick 
  # on gnome: gnome-screenshot 
  # on kde: spectacle
  # on x11: xsel
  # on wayland: wl-clipboard

  die(){
    notify-send "$1"
    exit 1
  }
  cleanup(){
    [[ -n $1 ]] && rm -r "$1"
  }

  SCR_IMG=$(mktemp -d) || die "failed to take screenshot"

  # shellcheck disable=SC2064
  trap "cleanup '$SCR_IMG'" EXIT

  #notify-send "Select the area of the text" 
  if  which "spectacle" &> /dev/null
  then
    spectacle -n -b -r -o "$SCR_IMG/scr.png" || die "failed to take screenshot"
  else
    gnome-screenshot -a -f "$SCR_IMG/scr.png" || die "failed to take screenshot"
  fi

  # increase image quality with option -q from default 75 to 100
  mogrify -modulate 100,0 -resize 400% "$SCR_IMG/scr.png"  || die "failed to convert image"
  #should increase detection rate

  tesseract "$SCR_IMG/scr.png" "$SCR_IMG/scr" &> /dev/null || die "failed to extract text"
  if [ "$XDG_SESSION_TYPE" == "wayland" ]
  then 
    wl-copy < "$SCR_IMG/scr.txt" || die "failed to copy text to clipboard"
  else
    # xsel -b -i  < "$SCR_IMG/scr.txt" || die "failed to copy text to clipboard"
    xclip -selection clipboard -i < "$SCR_IMG/scr.txt" || die "failed to copy text to clipboard"  
  fi
  # Notify the user what was copied but truncate the text to 100 characters
  notify-send "Text extracted from image" "$(head -c 100 "$SCR_IMG/scr.txt")" || die "failed to send notification"
  exit  #!/bin/bash 
  # Dependencies: tesseract-ocr imagemagick 
  # on gnome: gnome-screenshot 
  # on kde: spectacle
  # on x11: xsel
  # on wayland: wl-clipboard

  die(){
    notify-send "$1"
    exit 1
  }
  cleanup(){
    [[ -n $1 ]] && rm -r "$1"
  }

  SCR_IMG=$(mktemp -d) || die "failed to take screenshot"

  # shellcheck disable=SC2064
  trap "cleanup '$SCR_IMG'" EXIT

  #notify-send "Select the area of the text" 
  if  which "spectacle" &> /dev/null
  then
    spectacle -n -b -r -o "$SCR_IMG/scr.png" || die "failed to take screenshot"
  else
    gnome-screenshot -a -f "$SCR_IMG/scr.png" || die "failed to take screenshot"
  fi

  # increase image quality with option -q from default 75 to 100
  mogrify -modulate 100,0 -resize 400% "$SCR_IMG/scr.png"  || die "failed to convert image"
  #should increase detection rate

  tesseract "$SCR_IMG/scr.png" "$SCR_IMG/scr" &> /dev/null || die "failed to extract text"
  if [ "$XDG_SESSION_TYPE" == "wayland" ]
  then 
    wl-copy < "$SCR_IMG/scr.txt" || die "failed to copy text to clipboard"
  else
    # xsel -b -i  < "$SCR_IMG/scr.txt" || die "failed to copy text to clipboard"
    xclip -selection clipboard -i < "$SCR_IMG/scr.txt" || die "failed to copy text to clipboard"  
  fi
  # Notify the user what was copied but truncate the text to 100 characters
  notify-send "Text extracted from image" "$(head -c 100 "$SCR_IMG/scr.txt")" || die "failed to send notification"
  exit

For instance, I can't download completely youtube pages with videos using wget, but can with pywb (though pywb has issues with sites like reddit).

Not that I would necessarily use it for youtube pages, but that's an example of a complex page with lots of AJAX.

[–] TheTwelveYearOld@lemmy.world 1 points 1 week ago (6 children)

Doesn't work well for more complex sites.

 

For years I've on and off looked for web archiving software that can capture most sites, including ones that are "complex" with lots of AJAX and require logins like Reddit. Which ones have worked best for you?

Ideally I want one that can be started up programatically or via command line, an opens a chromium instance (or any browser), and captures everything shown on the page. I could also open the instance myself and log into sites and install addons like UBlock Origin. (btw, archiveweb.page must be started manually).

 

KDE has settings for shadows but they don't show on maximized windows (I have the maximize window gaps script installed). I'm wondering if there are any scripts that produce their own shadows.

 

I recently switched from Code Saver to my own Iosevka configuration, and at first I found it to look great in Neovide but too narrow in my terminal, especially with FFmpeg output. I thought maybe it was due to font rendering differences, like spacing or character widths. But then I took a screenshot with the font sizes set the same in both apps, and overlaid a word in one app to another ... and the text is rendered the same.

FFmpeg output for reference:

[out#0/mp4 @ 0x600000f14000] video:232962KiB audio:395KiB subtitle:0KiB other streams:0KiB global headers:0KiB muxing overhead: 0.017517%
frame= 1519 fps= 36 q=-1.0 Lsize=  233398KiB time=00:00:25.53 bitrate=74882.4kbits/s speed=0.606x
[libx264 @ 0x15a0062a0] frame I:18    Avg QP: 5.27  size:441876
[libx264 @ 0x15a0062a0] frame P:622   Avg QP: 8.04  size:264060
[libx264 @ 0x15a0062a0] frame B:879   Avg QP: 9.91  size: 75488
[–] TheTwelveYearOld@lemmy.world 0 points 2 weeks ago

except one time when I knocked a cup of water into one in 2005.

This but repeatedly for some people. I only drink from my metal bottles, and turn away from my computer. Admittedly I could be more careful by moving away from the computer but now its been years since it happened.

 

Crossposted from https://www.reddit.com/r/firefox/comments/1jd5nlk/convert_chrome_extension_to_firefox_addon/

There are a number of FF versions and forks that this will work with, but I used FF Beta (I've also confirmed it to work with FF Nightly & Iceraven. Conversely, it did not work for Mull and iirc, it cannot be done using FF Standard Release/Stable)

• Step 1 - have the CRX file for the Chrome extension handy. There are countless Chrome extensions and FF add-ons that will extract it for you.

• Step 2 - install the CRX Installer add-on (or get the XPI file by whatever means) →Extensions→Click CRX Installer→click "Browse"→ select the CRX file*, which should result in the creation of an XPI file.

• Step 3 - go to Settings→About Firefox Beta (or Nightly, Iceraven, etc)→Tap the logo at the top of the "About" section until you see a toast message saying "Debug Menu enabled" (I think 5 taps)

• Step 4 - navigate to "about:config" → search "xpinstall.signatures.required" →tap "Toggle" so that it displays "False" (make sure there's no whitespace; copy exactly what's between the quotation marks or the search won't return the corresponding flag)

• Step 5 - go back to the main Settings screen, and now under the Advanced section, after "Extensions" you should see "Install extension from file"→give that a tap tap taparoo (Happy Gilmore reference to lighten the mood 🤡)→select the previously created XPI file

• Step 6 = PROFIT!

💰💰💰

* I may have actually selected the .zip file converted from the extension CRX, but "conversion" in this case simply entails renaming the CRX file (i.e., change ".crx" to ".zip"). I doubt it makes a difference.

Edit - IDK why the link preview displays an add-on called WhatFont. The only hyperlink is for CRX Installer and I confirmed it redirects to its corresponding add-on store page ¯\_(ツ)_/¯

Edit 2 - I forgot to mention that this process will work to convert most extensions into properly functioning FF add-ons, but there will be the occasional outlier that doesn't function as well (or possibly at all) as a FF add-on due to differences in API calls. There are 1-2 that aren't available to both browsers and if the Chrome extension depends on one, functionality may suffer. Also, because FF is more permissive than Chrome in this regard, performing the conversion the other way around (from add-on→extension) is more likely to fail or result in a dysfunctional extension. Fortunately, due to there being a billion extensions in the CWS, most FF add-ons are already available to install.

Edit 3 - for a more automated approach, check out this handy tool created for the same purpose by u/hypeserver

[–] TheTwelveYearOld@lemmy.world -1 points 2 weeks ago (1 children)

DId u read the post? I'm on a MBP so I would dual boot to macOS (it's not possible to run windows on it rn without a VM).

 
 

The Linux Ship of Theseus

Crossposted from: https://lemmy.ml/post/27387345

  1. pick any distro and install it.
  2. Then, without installing another distro over the top of it, slowly convert it into another distro by replacing package managers, installed packages, and configurations.
  • System must be usable and fully native to the new distro (all old packages replaced with new ones).
  • No flatpaks, avoid snaps where physically possible, native packages only.

Difficulties:

  • Easy: pick two similar distros, such as Ubuntu and Debian or Manjaro and Arch and go from the base to the derivative.
  • Medium: Same as easy but go from the derivative to the base.
  • Hard: Pick two disparate distros like Debian and Artix and go from one to the other.
  • Nightmare: Make a self-compiled distro your target.

Clarifications

  • chroot, dd, debootstrap, and partition editors that allow you to install the new system in an empty container or blanket-overwrite the old system go against the spirit of this challenge.
  • These are very useful and valid tools under a normal context and I strongly recommend learning them.
  • You can use them if you prefer, but The ship of Theseus was replaced one board at a time. We are trying to avoid dropping a new ship in the harbor and tugging the old one out.
  • It may however be a good idea to use them to test out the target system in a safe environment as you perform the migration back in the real root, so you have a reference to go by.
[–] TheTwelveYearOld@lemmy.world -1 points 2 weeks ago

That hasn't really happened with macs even up to several years old with those parts irreplaceable, by the time that would happen the device should be replaced.

Yes replaceable parts would be better but the ones on Macs do in fact last a very long time.

[–] TheTwelveYearOld@lemmy.world -1 points 2 weeks ago (3 children)

Unfortunately it doesn't work on ARM devices right now.

view more: next ›